Index: branches/NERC/dev_r6998_ORCHESTRA/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- branches/NERC/dev_r6998_ORCHESTRA/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 7004)
+++ branches/NERC/dev_r6998_ORCHESTRA/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 7029)
@@ -7,4 +7,5 @@
    !!                 !  05-2008  (S. Alderson)  Modified for Interpolation in memory from input grid to model grid
    !!                 !  10-2013  (D. Delrosso, P. Oddo)  suppression of land point prior to interpolation
+   !!                 !  12-2015  (J. Harle) Adding BDY on-the-fly interpolation
    !!----------------------------------------------------------------------
 
@@ -67,4 +68,6 @@
       INTEGER                         ::   nreclast     ! last record to be read in the current file
       CHARACTER(len = 256)            ::   lsmname      ! current name of the NetCDF mask file acting as a key
+      INTEGER                         ::   igrd         ! grid type for bdy data
+      INTEGER                         ::   ibdy         ! bdy set id number
    END TYPE FLD
 
@@ -114,5 +117,5 @@
 CONTAINS
 
-   SUBROUTINE fld_read( kt, kn_fsbc, sd, map, kit, kt_offset )
+   SUBROUTINE fld_read( kt, kn_fsbc, sd, map, kit, kt_offset, jpk_bdy, fvl )
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE fld_read  ***
@@ -135,4 +138,7 @@
       !                                                     !   kt_offset = +1 => fields at "after"  time level
       !                                                     !   etc.
+      INTEGER  , INTENT(in   ), OPTIONAL     ::   jpk_bdy   ! number of vertical levels in the BDY data
+      LOGICAL  , INTENT(in   ), OPTIONAL     ::   fvl   ! number of vertical levels in the BDY data
+      !!
       INTEGER  ::   itmp         ! local variable
       INTEGER  ::   imf          ! size of the structure sd
@@ -171,5 +177,9 @@
          DO jf = 1, imf 
             IF( PRESENT(map) ) imap = map(jf)
-            CALL fld_init( kn_fsbc, sd(jf), imap )  ! read each before field (put them in after as they will be swapped)
+               IF( PRESENT(jpk_bdy) ) THEN
+                  CALL fld_init( kn_fsbc, sd(jf), imap, jpk_bdy, fvl )  ! read each before field (put them in after as they will be swapped)
+               ELSE
+                  CALL fld_init( kn_fsbc, sd(jf), imap )  ! read each before field (put them in after as they will be swapped)
+               ENDIF
          END DO
          IF( lwp ) CALL wgt_print()                ! control print
@@ -263,6 +273,9 @@
 
                ! read after data
-               CALL fld_get( sd(jf), imap )
-
+               IF( PRESENT(jpk_bdy) ) THEN
+                  CALL fld_get( sd(jf), imap, jpk_bdy, fvl)
+               ELSE
+                  CALL fld_get( sd(jf), imap )
+               ENDIF
             ENDIF   ! read new data?
          END DO                                    ! --- end loop over field --- !
@@ -302,5 +315,5 @@
 
 
-   SUBROUTINE fld_init( kn_fsbc, sdjf, map )
+   SUBROUTINE fld_init( kn_fsbc, sdjf, map , jpk_bdy, fvl)
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE fld_init  ***
@@ -309,7 +322,9 @@
       !!               - if time interpolation, read before data 
       !!----------------------------------------------------------------------
-      INTEGER  , INTENT(in   ) ::   kn_fsbc   ! sbc computation period (in time step) 
-      TYPE(FLD), INTENT(inout) ::   sdjf      ! input field related variables
-      TYPE(MAP_POINTER),INTENT(in) ::   map   ! global-to-local mapping indices
+      INTEGER  , INTENT(in   ) ::   kn_fsbc      ! sbc computation period (in time step) 
+      TYPE(FLD), INTENT(inout) ::   sdjf         ! input field related variables
+      TYPE(MAP_POINTER),INTENT(in) ::   map      ! global-to-local mapping indices
+      INTEGER  , INTENT(in), OPTIONAL :: jpk_bdy ! number of vertical levels in the BDY data
+      LOGICAL  , INTENT(in), OPTIONAL :: fvl     ! number of vertical levels in the BDY data
       !!
       LOGICAL :: llprevyr              ! are we reading previous year  file?
@@ -405,5 +420,10 @@
          ENDIF
          !
-         CALL fld_get( sdjf, map )         ! read before data in after arrays(as we will swap it later)
+         ! read before data in after arrays(as we will swap it later)
+         IF( PRESENT(jpk_bdy) ) THEN
+            CALL fld_get( sdjf, map, jpk_bdy, fvl )
+         ELSE
+            CALL fld_get( sdjf, map )
+         ENDIF
          !
          clfmt = "('fld_init : time-interpolation for ', a, ' read previous record = ', i6, ' at time = ', f7.2, ' days')"
@@ -581,5 +601,5 @@
 
 
-   SUBROUTINE fld_get( sdjf, map )
+   SUBROUTINE fld_get( sdjf, map, jpk_bdy, fvl )
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE fld_get  ***
@@ -589,4 +609,6 @@
       TYPE(FLD)        , INTENT(inout) ::   sdjf   ! input field related variables
       TYPE(MAP_POINTER), INTENT(in   ) ::   map    ! global-to-local mapping indices
+      INTEGER  , INTENT(in), OPTIONAL  ::   jpk_bdy ! number of vertical levels in the bdy data
+      LOGICAL  , INTENT(in), OPTIONAL  ::   fvl     ! number of vertical levels in the bdy data
       !
       INTEGER ::   ipk      ! number of vertical levels of sdjf%fdta ( 2D: ipk=1 ; 3D: ipk=jpk )
@@ -601,7 +623,15 @@
       !
       IF( ASSOCIATED(map%ptr) ) THEN
-         IF( sdjf%ln_tint ) THEN   ;   CALL fld_map( sdjf%num, sdjf%clvar, sdjf%fdta(:,:,:,2), sdjf%nrec_a(1), map )
-         ELSE                      ;   CALL fld_map( sdjf%num, sdjf%clvar, sdjf%fnow(:,:,:  ), sdjf%nrec_a(1), map )
-         ENDIF
+         IF( PRESENT(jpk_bdy) ) THEN
+            IF( sdjf%ln_tint ) THEN   ;   CALL fld_map( sdjf%num, sdjf%clvar, sdjf%fdta(:,:,:,2),                &
+                                                        sdjf%nrec_a(1), map, sdjf%igrd, sdjf%ibdy, jpk_bdy, fvl )
+            ELSE                      ;   CALL fld_map( sdjf%num, sdjf%clvar, sdjf%fnow(:,:,:  ),                &
+                                                        sdjf%nrec_a(1), map, sdjf%igrd, sdjf%ibdy, jpk_bdy, fvl )
+            ENDIF
+         ELSE
+            IF( sdjf%ln_tint ) THEN   ;   CALL fld_map( sdjf%num, sdjf%clvar, sdjf%fdta(:,:,:,2), sdjf%nrec_a(1), map )
+            ELSE                      ;   CALL fld_map( sdjf%num, sdjf%clvar, sdjf%fnow(:,:,:  ), sdjf%nrec_a(1), map )
+            ENDIF
+         ENDIF        
       ELSE IF( LEN(TRIM(sdjf%wgtname)) > 0 ) THEN
          CALL wgt_list( sdjf, iw )
@@ -658,6 +688,5 @@
    END SUBROUTINE fld_get
 
-
-   SUBROUTINE fld_map( num, clvar, dta, nrec, map )
+   SUBROUTINE fld_map( num, clvar, dta, nrec, map, igrd, ibdy, jpk_bdy, fvl )
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE fld_map  ***
@@ -667,11 +696,14 @@
       !!----------------------------------------------------------------------
 #if defined key_bdy
-      USE bdy_oce, ONLY:  dta_global, dta_global2         ! workspace to read in global data arrays
+      USE bdy_oce, ONLY:  idx_bdy, dta_global, dta_global_z, dta_global_dz, dta_global2, dta_global2_z, dta_global2_dz                 ! workspace to read in global data arrays
 #endif 
       INTEGER                   , INTENT(in ) ::   num     ! stream number
       CHARACTER(LEN=*)          , INTENT(in ) ::   clvar   ! variable name
-      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   dta   ! output field on model grid (2 dimensional)
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   dta     ! output field on model grid (2 dimensional)
       INTEGER                   , INTENT(in ) ::   nrec    ! record number to read (ie time slice)
       TYPE(MAP_POINTER)         , INTENT(in ) ::   map     ! global-to-local mapping indices
+      INTEGER  , INTENT(in), OPTIONAL         ::   igrd, ibdy, jpk_bdy  ! grid type, set number and number of vertical levels in the bdy data
+      LOGICAL  , INTENT(in), OPTIONAL         ::   fvl     ! grid type, set number and number of vertical levels in the bdy data
+      INTEGER                                 ::   jpkm1_bdy! number of vertical levels in the bdy data minus 1
       !!
       INTEGER                                 ::   ipi      ! length of boundary data on local process
@@ -682,5 +714,8 @@
       INTEGER                                 ::   ib, ik, ji, jj   ! loop counters
       INTEGER                                 ::   ierr
-      REAL(wp), POINTER, DIMENSION(:,:,:)     ::   dta_read  ! work space for global data
+      REAL(wp)                                ::   fv          ! fillvalue 
+      REAL(wp), POINTER, DIMENSION(:,:,:)     ::   dta_read    ! work space for global data
+      REAL(wp), POINTER, DIMENSION(:,:,:)     ::   dta_read_z  ! work space for global data
+      REAL(wp), POINTER, DIMENSION(:,:,:)     ::   dta_read_dz ! work space for global data
       !!---------------------------------------------------------------------
       !
@@ -696,6 +731,20 @@
       IF( map%ll_unstruc) THEN   ! unstructured open boundary data file
          dta_read => dta_global
-      ELSE                       ! structured open boundary data file
+         IF( PRESENT(jpk_bdy) ) THEN
+            IF( jpk_bdy>0 ) THEN
+               dta_read_z => dta_global_z
+               dta_read_dz => dta_global_dz
+               jpkm1_bdy = jpk_bdy-1
+            ENDIF
+         ENDIF
+      ELSE                       ! structured open boundary file
          dta_read => dta_global2
+         IF( PRESENT(jpk_bdy) ) THEN
+            IF( jpk_bdy>0 ) THEN
+               dta_read_z => dta_global2_z
+               dta_read_dz => dta_global2_dz
+               jpkm1_bdy = jpk_bdy-1
+            ENDIF
+         ENDIF
       ENDIF
 #endif
